"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useControlState = useControlState;
var _react = require("react");
var _usePropsUpdate = require("../usePropsUpdate");
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
// eslint-disable-next-line @typescript-eslint/ban-types
var isFunction = function isFunction(x) {
  return typeof x === 'function';
};
function useControlState(_ref) {
  var value = _ref.value,
    defaultValue = _ref.defaultValue,
    defaultStateValue = _ref.defaultStateValue,
    onChange = _ref.onChange;
  var _useState = (0, _react.useState)(function () {
      var finalValue;
      if (value !== undefined) {
        finalValue = value;
      } else if (defaultValue !== undefined) {
        finalValue = defaultValue;
      } else {
        finalValue = isFunction(defaultStateValue) ? defaultStateValue() : defaultStateValue;
      }
      return finalValue;
    }),
    _useState2 = _slicedToArray(_useState, 2),
    mergedValue = _useState2[0],
    setMergedValue = _useState2[1];
  (0, _usePropsUpdate.usePropsUpdate)(function () {
    return setMergedValue(value === undefined ? defaultStateValue : value);
  }, [value, defaultStateValue]);
  var onChangeHandle = (0, _react.useCallback)(function (nextValue) {
    onChange === null || onChange === void 0 ? void 0 : onChange(nextValue, mergedValue);
    value === undefined && setMergedValue(nextValue);
  }, [value, mergedValue, onChange]);
  return [mergedValue, onChangeHandle];
}