import { RefObject } from 'react';
declare type Align = 'top' | 'bottom' | 'left' | 'right' | 'vertical' | 'horizontal';
declare type Float = 'start' | 'end' | 'center';
interface Coords {
    x: number;
    y: number;
}
export interface UseDropCallbacks {
    onHide?: () => void;
}
export interface UseDropConfig {
    align?: Align;
    float?: Float;
    margins?: Coords;
    autoFixPosition?: boolean;
    fixed?: boolean;
    coords?: Coords;
    container?: HTMLElement;
    parentRef?: RefObject<HTMLElement>;
    followParentWhenScroll?: boolean;
    callbacks?: UseDropCallbacks;
    fitListToParent?: boolean;
}
export declare const useDrop: <El extends HTMLElement>(config: UseDropConfig) => RefObject<El>;
export {};
