"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.usePortal = exports.default = void 0;
var _react = require("react");
var usePortal = function usePortal(component, id) {
  var createElement = (0, _react.useCallback)(function () {
    if (typeof document !== 'undefined') {
      // Checking if a document exists for SSR

      var portal = 'portal';
      var element = document.getElementById(component !== null && component !== void 0 ? component : portal);
      if (element) {
        return element;
      }
      var div = document.createElement('div');
      div.id = component !== null && component !== void 0 ? component : portal;
      return div;
    }
    return null;
  }, []);
  var rootRef = (0, _react.useRef)(createElement());
  (0, _react.useEffect)(function () {
    // Look for existing target dom element to append to
    var parent = id && document.querySelector("#".concat(id)) || document.body;
    if (rootRef.current) {
      // Add the detached element to the parent
      parent.appendChild(rootRef.current);
    }
  }, []);
  return rootRef.current;
};
exports.usePortal = usePortal;
var _default = usePortal;
exports.default = _default;