"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useWindowResize = void 0;
var _react = require("react");
var _useDebounce = require("../useDebounce");
var useWindowResize = function useWindowResize(resizeHandler) {
  var debouncer = (0, _useDebounce.useDebounce)(resizeHandler, 0);
  (0, _react.useEffect)(function () {
    window.addEventListener('resize', debouncer, false);
    return function () {
      window.removeEventListener('resize', debouncer);
    };
  }, [debouncer]);
};
exports.useWindowResize = useWindowResize;