function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
var getParents = function getParents(pNode, parents) {
  if (pNode === null || pNode.parentNode === null) {
    return parents;
  }
  return getParents(pNode.parentElement, parents.concat([pNode]));
};
var style = function style(pNode, prop) {
  return getComputedStyle(pNode, null).getPropertyValue(prop);
};
var overflow = function overflow(pNode) {
  return style(pNode, 'overflow') + style(pNode, 'overflow-y') + style(pNode, 'overflow-x');
};
var scroll = function scroll(pNode) {
  return /(hidden)/.test(overflow(pNode));
};
export function getOverflowParent(node) {
  var getAll = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  /* eslint-disable consistent-return */
  var scrollParent = function scrollParent(pNode) {
    var _document$scrollingEl, _document, _document2;
    if (!(pNode instanceof HTMLElement || pNode instanceof SVGElement)) {
      return;
    }
    var parents = getParents(pNode.parentElement, []);
    var _iterator = _createForOfIteratorHelper(parents),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var parent = _step.value;
        if (scroll(parent)) {
          return parent;
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    return (_document$scrollingEl = (_document = document) === null || _document === void 0 ? void 0 : _document.scrollingElement) !== null && _document$scrollingEl !== void 0 ? _document$scrollingEl : (_document2 = document) === null || _document2 === void 0 ? void 0 : _document2.documentElement;
  };
  if (!getAll) {
    return scrollParent(node);
    /* eslint-enable consistent-return */
  }
  var result = [];
  var elem = node;
  do {
    var _document3;
    elem = scrollParent(elem);
    if (elem) {
      result.push(elem);
    }
  } while (elem && elem !== ((_document3 = document) === null || _document3 === void 0 ? void 0 : _document3.documentElement));
  return result;
}