import { useCallback, useEffect, useRef } from 'react';
export var usePortal = function usePortal(component, id) {
  var createElement = useCallback(function () {
    if (typeof document !== 'undefined') {
      // Checking if a document exists for SSR

      var portal = 'portal';
      var element = document.getElementById(component !== null && component !== void 0 ? component : portal);
      if (element) {
        return element;
      }
      var div = document.createElement('div');
      div.id = component !== null && component !== void 0 ? component : portal;
      return div;
    }
    return null;
  }, []);
  var rootRef = useRef(createElement());
  useEffect(function () {
    // Look for existing target dom element to append to
    var parent = id && document.querySelector("#".concat(id)) || document.body;
    if (rootRef.current) {
      // Add the detached element to the parent
      parent.appendChild(rootRef.current);
    }
  }, []);
  return rootRef.current;
};
export default usePortal;