import { useEffect } from 'react';
import { useDebounce } from '../useDebounce';
export var useWindowResize = function useWindowResize(resizeHandler) {
  var debouncer = useDebounce(resizeHandler, 0);
  useEffect(function () {
    window.addEventListener('resize', debouncer, false);
    return function () {
      window.removeEventListener('resize', debouncer);
    };
  }, [debouncer]);
};